%define sysconfdir /var/lib/axtu
%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_sitelib_withplatform: %define python_sitelib_withplatform %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

Summary: Support programs and libraries for Asianux TSN
License: GPLv2
Group: System Environment/Base
Source0: %{name}-%{version}.tar.gz
Source1: rhnlib.tgz
Source2: axtu.conf
Source3: axtsn-common-libraries-1.0.tgz
Source4: ja.po
Source5: ko.po 
Source6: zh_CN.po  
Source7: zh_TW.po
Source8: vi.po
Patch0: axtsn-client-tools-4.0-change-config-file.patch
Patch1: axtsn-client-tools-4.0-change-desktop-menu.patch
Patch2: axtsn-client-tools-4.0-change-tui-interface.patch
Patch3: axtsn-client-tools-4.0-change-gui-interface.patch
Patch4: axtsn-client-tools-4.0-addFunc.patch
Patch5: axtsn-client-tools-4.0-modify-setup-name.patch
Patch6: axtsn-client-tools-4.0-change-tui-process.patch
Patch7: axtsn-client-tools-4.0-gui-use-common-libraries.patch
Patch8: axtsn-client-tools-4.0-fix-tui-process.patch
Patch9: axtsn-client-tools-4.0-addproxy.patch
Patch10:axtsn-client-tools-4.0-fix-functions-bugs.patch
Patch11:axtsn-client-tools-4.0-fix-secBatch-bugs.patch
Patch12:axtsn-client-tools-4.0-desktop.patch
Patch13:axtsn-client-tools-4.0-fix-thdBatch.patch
Patch14:axtsn-client-tools-4.0-add-systemnameentry-in-loginpage.patch
Patch15:axtsn-client-tools-4.0-skip-loginafterpage.patch
Patch16:axtsn-client-tools-4.0-fix-NoFixedNIC.patch
Patch17:axtsn-client-tools-4.0-addHancom-License-format.patch
Patch18:axtsn-client-tools-4.0-fix-useless-message.patch
Patch19:axtsn-client-tools-4.0-change-signupURL-ML.patch
Patch20:axtsn-client-tools-4.0-remove-check-user-interface-in-hancom.patch
Patch21:axtsn-client-tools-4.0-fix-firstboot-tab.patch
Patch22:axtsn-client-tools-4.0-fix-SupportedEmNIC.patch
Patch23:axtsn-client-tools-4.0-fix-SecurityProtocol.patch
Patch24:axtsn-client-tools-4.0-proxyTUI.patch
Patch25:axtsn-client-tools-4.0-edit-Makefile.patch

Name: axtsn-client-tools
Version: 4.0
Release: 19%{?dist}
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Requires: rpm >= 4.2.3-24_nonptl
Requires: rpm-python 
Requires: python-ethtool
Requires: gnupg
Requires: sh-utils
Requires: dbus-python
%if 0%{?fedora} > 12 || 0%{?rhel} > 5
Requires: python-gudev
Requires: hwdata
%else
Requires: hal >= 0.5.8.1-52
%endif
Requires: newt
Requires: python-dmidecode
Requires: libxml2-python
Requires: pyOpenSSL

Conflicts: up2date < 5.0.0

BuildRequires: python-devel
BuildRequires: gettext
BuildRequires: intltool
BuildRequires: desktop-file-utils
BuildRequires: asianux-logos
BuildRequires: zlib-devel
BuildRequires: libxml2-devel
BuildRequires: rpm-devel

# The following BuildRequires are for check only
%if 0%{?fedora} >= 12
BuildRequires: python-coverage
# python-setuptools can be removed when 556290 gets fixed
BuildRequires: python-setuptools
BuildRequires: rpm-python
%endif

%description
Asianux TSN Client Tools provides programs and libraries to allow your
system to receive software updates from Asianux TSN.

%package -n axtsn-check
Summary: Check for RHN actions
Group: System Environment/Base
Requires: %{name} = %{version}-%{release}
Requires: yum-axtu-plugin >= 0.5.3-30
BuildArch: noarch

%description -n axtsn-check
axtsn-check polls a Asianux TSN server to find and execute scheduled actions.

%package -n axtsn-setup
Summary: Configure and register an Asianux TSN client
Group: System Environment/Base
Requires: usermode >= 1.36
Requires: %{name} = %{version}-%{release}
BuildArch: noarch

%description -n axtsn-setup
axtsn-setup contains programs and utilities to configure a system to use
Asianux TSN, and to register a system with a Asianux TSN server.

%package -n axtsn-setup-gnome
Summary: A GUI interface for Asianux TSN
Group: System Environment/Base
Requires: %{name} = %{version}-%{release}
Requires: axtsn-setup = %{version}-%{release}
Requires: pam >= 0.72
Requires: pygtk2 pygtk2-libglade gnome-python2 gnome-python2-canvas
Requires: usermode-gtk
Requires: gnome-python2-gnome gnome-python2-bonobo
Requires: liberation-sans-fonts
BuildArch: noarch

%description -n axtsn-setup-gnome
axtsn-setup-gnome contains a GTK+ graphical interface for configuring and
registering a system with a Asianux TSN server.


%prep
%setup -q -a 3
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1

%build
cp %{SOURCE4} %{SOURCE5} %{SOURCE6} %{SOURCE7} %{SOURCE8} po/
make -f Makefile.rhn-client-tools

#build axtsn-common-libraries
pushd axtsn-common-libraries-1.0
export CDIR=$PWD
make
popd

%install
rm -rf $RPM_BUILD_ROOT
make -f Makefile.rhn-client-tools install VERSION=%{version}-%{release} PREFIX=$RPM_BUILD_ROOT MANPATH=%{_mandir}

mkdir -p $RPM_BUILD_ROOT/var/lib/up2date
mkdir -pm700 $RPM_BUILD_ROOT%{_localstatedir}/spool/up2date

%if 0%{?fedora} > 12 || 0%{?rhel} > 5
rm $RPM_BUILD_ROOT%{_datadir}/rhn/up2date_client/hardware_hal.*
%else
rm $RPM_BUILD_ROOT%{_datadir}/rhn/up2date_client/hardware_gudev.*
%endif

%if 0%{?rhel} > 0 && 0%{?rhel} < 6
rm -rf $RPM_BUILD_ROOT%{_datadir}/rhn/up2date_client/firstboot
rm -f $RPM_BUILD_ROOT%{_datadir}/firstboot/modules/rhn_register.*
%else
rm -rf $RPM_BUILD_ROOT%{_datadir}/firstboot/modules/rhn_*_*.*
%endif

desktop-file-install --dir=${RPM_BUILD_ROOT}%{_datadir}/applications --vendor=rhn rhn_register.desktop

%find_lang rhn-client-tools

mv rhn-client-tools.lang axtsn-client-tools.lang

mkdir -p $RPM_BUILD_ROOT/%{python_sitelib}/
tar zxf %{SOURCE1} -C $RPM_BUILD_ROOT/%{python_sitelib}/

mv ${RPM_BUILD_ROOT}%{_bindir}/rhn_register ${RPM_BUILD_ROOT}%{_bindir}/axtsn_register
mv ${RPM_BUILD_ROOT}%{_sbindir}/rhn_register ${RPM_BUILD_ROOT}%{_sbindir}/axtsn_register
mv ${RPM_BUILD_ROOT}%{_sysconfdir}/pam.d/rhn_register ${RPM_BUILD_ROOT}%{_sysconfdir}/pam.d/axtsn_register
mv ${RPM_BUILD_ROOT}%{_sysconfdir}/security/console.apps/rhn_register ${RPM_BUILD_ROOT}%{_sysconfdir}/security/console.apps/axtsn_register
sed -i 's/rhn_register/axtsn_register/' ${RPM_BUILD_ROOT}%{_sysconfdir}/security/console.apps/axtsn_register
mv ${RPM_BUILD_ROOT}%{_datadir}/applications/rhn_register.desktop ${RPM_BUILD_ROOT}%{_datadir}/applications/axtsn_register.desktop
sed -i 's/rhn_register/axtsn_register/' ${RPM_BUILD_ROOT}%{_datadir}/applications/axtsn_register.desktop

(cd ${RPM_BUILD_ROOT}%{_datadir}/applications/; patch -p1 < %{PATCH12})
install -m 644 src/up2date_client/axtu-authen-client-addr.conf $RPM_BUILD_ROOT%{_datadir}/rhn/up2date_client/
install -m 644 src/up2date_client/axtuCommon.py $RPM_BUILD_ROOT%{_datadir}/rhn/up2date_client/

mkdir -p ${RPM_BUILD_ROOT}%{sysconfdir}/tmp
install -m 644 %{SOURCE2} ${RPM_BUILD_ROOT}%{sysconfdir}/

#install axtsn-common-libraries
pushd axtsn-common-libraries-1.0
make DISTDIR=${RPM_BUILD_ROOT} install
popd

mkdir -p ${RPM_BUILD_ROOT}/etc/ld.so.conf.d
echo "%{python_sitelib_withplatform}" > ${RPM_BUILD_ROOT}/etc/ld.so.conf.d/axtsn-client-tools.conf

%post
rm -f %{_localstatedir}/spool/up2date/loginAuth.pkl
/sbin/ldconfig

%post -n axtsn-setup-gnome
touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :

%postun -n axtsn-setup-gnome
if [ $1 -eq 0 ] ; then
    touch --no-create %{_datadir}/icons/hicolor &>/dev/null
    gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
fi

%posttrans -n axtsn-setup-gnome
gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :


%clean
rm -rf $RPM_BUILD_ROOT

%if 0%{?fedora} >= 12
%check

make -f Makefile.axtsn-client-tools test
%endif

%files -f %{name}.lang
%defattr(-,root,root,-)
# some info about mirrors
%doc doc/LICENSE
%{_mandir}/man8/rhn-profile-sync.8*
%{_mandir}/man5/up2date.5*

%dir %{sysconfdir}
%dir %{sysconfdir}/tmp
%dir %{sysconfdir}/clientCaps.d
%dir %{sysconfdir}/allowed-actions
%dir %{sysconfdir}/allowed-actions/configfiles
%dir %{sysconfdir}/allowed-actions/script
%config(noreplace) %{sysconfdir}/axtu.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/up2date
%config(noreplace) %{_sysconfdir}/rpm/macros.up2date

# dirs
%dir %{_datadir}/rhn
%dir %{_datadir}/rhn/up2date_client
%dir %{_localstatedir}/spool/up2date

#files
%{_datadir}/rhn/up2date_client/__init__.*
%{_datadir}/rhn/up2date_client/config.*
%{_datadir}/rhn/up2date_client/haltree.*
%{_datadir}/rhn/up2date_client/hardware*
%{_datadir}/rhn/up2date_client/hwdata.*
%{_datadir}/rhn/up2date_client/up2dateUtils.*
%{_datadir}/rhn/up2date_client/up2dateLog.*
%{_datadir}/rhn/up2date_client/up2dateErrors.*
%{_datadir}/rhn/up2date_client/up2dateAuth.*
%{_datadir}/rhn/up2date_client/rpcServer.*
%{_datadir}/rhn/up2date_client/rhnserver.*
%{_datadir}/rhn/up2date_client/rpmUtils.*
%{_datadir}/rhn/up2date_client/rhnPackageInfo.*
%{_datadir}/rhn/up2date_client/rhnChannel.*
%{_datadir}/rhn/up2date_client/rhnHardware.*
%{_datadir}/rhn/up2date_client/transaction.*
%{_datadir}/rhn/up2date_client/clientCaps.*
%{_datadir}/rhn/up2date_client/capabilities.*
%{_datadir}/rhn/up2date_client/rhncli.*
%{_datadir}/rhn/up2date_client/axtu-authen-client-addr.conf
%{_datadir}/rhn/up2date_client/axtuCommon.*
%{_datadir}/rhn/__init__.*

# Asianux
/etc/ld.so.conf.d/axtsn-client-tools.conf

%{_sbindir}/rhn-profile-sync

#public keys and certificates
%{_datadir}/rhn/RHNS-CA-CERT

%{python_sitelib}/*

%if "%{python_sitelib}" != "%{python_sitelib_withplatform}"
%{python_sitelib_withplatform}/*
%endif

%files -n axtsn-check
%defattr(-,root,root,-)
%dir %{_datadir}/rhn/actions
%{_mandir}/man8/rhn_check.8*

%{_sbindir}/rhn_check

%{_datadir}/rhn/up2date_client/getMethod.*

# actions for rhn_check to run
%{_datadir}/rhn/actions/__init__.*
%{_datadir}/rhn/actions/hardware.*
%{_datadir}/rhn/actions/errata.*
%{_datadir}/rhn/actions/systemid.*
%{_datadir}/rhn/actions/reboot.*
%{_datadir}/rhn/actions/rhnsd.*
%{_datadir}/rhn/actions/up2date_config.*

%files -n axtsn-setup
%defattr(-,root,root,-)
%{_mandir}/man8/rhnreg_ks.8*
%{_mandir}/man8/rhn_register.8*
%{_mandir}/man8/spacewalk-channel.8*

%config(noreplace) %{_sysconfdir}/security/console.apps/axtsn_register
%config(noreplace) %{_sysconfdir}/pam.d/axtsn_register

%{_bindir}/axtsn_register
%{_sbindir}/axtsn_register
%{_sbindir}/rhnreg_ks
%{_sbindir}/spacewalk-channel
%{_sbindir}/rhn-channel

%{_datadir}/rhn/up2date_client/rhnreg.*
%{_datadir}/rhn/up2date_client/tui.*
%{_datadir}/rhn/up2date_client/rhnreg_constants.*

%{_datadir}/setuptool/setuptool.d/99tsn_register

%files -n axtsn-setup-gnome
%defattr(-,root,root,-)
%{_datadir}/rhn/up2date_client/messageWindow.*
%{_datadir}/rhn/up2date_client/rhnregGui.*
%{_datadir}/rhn/up2date_client/rh_register.glade
%{_datadir}/rhn/up2date_client/gui.*
%{_datadir}/rhn/up2date_client/progress.*
%{_datadir}/pixmaps/*png
%{_datadir}/icons/hicolor/16x16/apps/up2date.png
%{_datadir}/icons/hicolor/24x24/apps/up2date.png
%{_datadir}/icons/hicolor/32x32/apps/up2date.png
%{_datadir}/icons/hicolor/48x48/apps/up2date.png
%{_datadir}/applications/axtsn_register.desktop

%if 0%{?rhel} > 0 && 0%{?rhel} < 6
%{_datadir}/firstboot/modules/rhn_login_gui.*
%{_datadir}/firstboot/modules/rhn_register_firstboot_gui_window.*
%{_datadir}/firstboot/modules/rhn_start_gui.*
%{_datadir}/firstboot/modules/rhn_choose_server_gui.*
%{_datadir}/firstboot/modules/rhn_provide_certificate_gui.*
%{_datadir}/firstboot/modules/rhn_create_profile_gui.*
%{_datadir}/firstboot/modules/rhn_finish_gui.*
%else
%{_datadir}/firstboot/modules/rhn_register.*
%{_datadir}/rhn/up2date_client/firstboot/rhn_login_gui.*
%{_datadir}/rhn/up2date_client/firstboot/rhn_start_gui.*
%{_datadir}/rhn/up2date_client/firstboot/rhn_choose_server_gui.*
%{_datadir}/rhn/up2date_client/firstboot/rhn_provide_certificate_gui.*
%{_datadir}/rhn/up2date_client/firstboot/rhn_create_profile_gui.*
%{_datadir}/rhn/up2date_client/firstboot/rhn_finish_gui.*
%endif


%changelog
* Tue Mar 3 2015 Bruce Dang <bruce.dang@asianux.com> - 4.0-19
- Add axtsn-client-tools.conf into /etc/ld.so.conf.d

* Wed Feb 25 2015 Bruce Dang <bruce.dang@asianux.com> - 4.0-18
- Edit Python lib in Makefile of axtsn-common-libraries (Patch25)

* Fri Feb 6 2015 Bruce Dang <bruce.dang@asianux.com> - 4.0-17
- Add configuration HTTP Proxy for TUI mode (AxBug#12751, Patch 24)

* Mon Oct 27 2014 Jack Ngo <jack.ngo@asianux.com> - 4.0-16
- fix Authentication Server Protocol(AxBug12748, Patch 23)

* Wed Jun 11 2014 Peaches Vo <peaches.vo@asianux.com> - 4.0-15
- fix bug #10423 axtsn_register can't work properly without eth0, support emX
- added Patch22

* Fri Nov 1 2013 Bill Ye <ting.ye@asianux.com> - 4.0-14
- fix unable tab in firstboot(AxBug11854, Patch21) 

* Tue May 7 2013 JeongHun Kim <jhkim@hancom.com> -4.0-13
- remove id, password input ui for Hancom on GUI and TUI (AxBug10965, Patch20)

* Fri Mar 22 2013 Mika Kamei <mika.kamei@miraclelinux.com> - 4.0-12
- change Sign Up URL in ML to "https://users.miraclelinux.com/user/user.html"
  (AXBug#11406, Patch19)

* Wed Oct 24 2012 Mika Kamei <mika.kamei@miraclelinux.com> - 4.0-11
- correct Japanese translation and add massages for --nox to ja.po (AXBug#9827,
  Source4)

* Fri Sep 21 2012 Saori Munakata <saori.munakata@miraclelinux.com> -4.0-10
- replace ja.po (AxBug10317, Source4)

* Thu Sep 20 2012 Bill Ye <ting.ye@asianux.com> - 4.0-9
- fix useless message in register success page.(AxBug10424, patch18)

* Mon Jul 9 2012 Bill Ye <ting.ye@asianux.com> - 4.0-8
- add register information (AxBug10399, patch14)
- skip some register page (AxBug10401, patch15) 
- fix using the fixed NIC (AxBug10423, patch16)
- add the License format of Hancom (AxBug10718, patch17)

* Fri Feb 18 2011 Bill Ye <ting.ye@asianux.com> 4.0-7
- fix bugs(bug8906, 8909, 8913, 8915, 8919 and bug8959, patch13)
- bug8906 wrong character "infomation" from "information"
- bug8909 some hardware information has not been collected
- bug8913 misspelling of "reache"
- bug8915 In tsn local website not found the system name that added in firstboot registration
- bug8919 Cursor to be maintain "processing" status after error occurred
- bug8959 "only for one machine" spelling mistake and not easy to understand 

* Wed Jan 12 2011 Bill Ye <ting.ye@asianux.com> 4.0-6
- fix bugs(bug8835, 8836, 8837, 8838, 8839, 8840, 8843, 8844, 8845, 
  8847, 8849, 8850, 8852, 8854, 8860, 8866 and bug8873, patch11)
- bug8835 redhat string is included in Asianux TSN TUI mode
- bug8836 redhat information in transferring profile information process 
- bug8837 tool name rhn_register was not changed to axtsn_register in log file
- bug8838 error information with "redhat" character in popup dialog
- bug8839 clearly message to avoid misunderstanding operation and modify wrong word
- bug8840 One sentence showed not same as others in axtsn_register page
- bug8843 error messages when a normal user try to use yum
- bug8844 TUI register tool quit suddently when there is no network
- bug8845 TUI will block and crash without server information in /etc/hosts
- bug8847 Registration in firstboot show successful information even user do not register at all
- bug8849 wrong title in firstboot
- bug8850 wrong title in firstboot
- bug8852 wrong function while updating Asianux without active networking
- bug8854 wrong Asianux version while getting hardware profile
- bug8860 Not provide useful URL in production key page
- bug8866 wrong logical for "setup fail"
- bug8873 not support WTEC
- modify multi-language translations for asianux tsn requirements
  (patch12, zh_CN.po, zh_TW.po, ja.po, ko.po, vi.po)

* Fri Jan 7 2011 Bill Ye <ting.ye@asianux.com> 4.0-5
- fix bugs(Bug8834, Bug8839, Bug8851, Bug8855, Bug8861, patch10) 
- Bug8834, URL will be wrote again when you press "Back" and "Forward"
- Bug8839, clearly message to avoid misunderstanding operation
- Bug8851, the last page wrong
- Bug8855, empty page while reviewing subscription
- Bug8861, RedFlag asked to change their license format

* Thu Jan 06 2011 Hua Jie <jie.hua@asianux.com> 4.0-4
- include axtsn-common-libraries below from yum-axtu-plugin(Bug #8862)
  - axtuPost.so, libgetHash.so, libaxhdinfo.so and libaxswinfo.so
- include /var/lib/axtu/tmp/

* Tue Jan 4 2011 Bill Ye <ting.ye@asianux.com> 4.0-3
- add proxy function (Bug8766, patch9)

* Mon Dec 20 2010 Liu Tingting <maggie.liu@asianux.com> 4.0-2
- Modify name of the program (bug8800,patch5)
- Modify tui process to satisfy ax (patch6,patch8) 
- Modify gui to satisfy ax (bug8812,patch7)
- Modify name of the program in spec (bug8821)

* Thu Dec 02 2010 Hua Jie <jie.hua@asianux.com> 4.0-1.1%{?dist}
- include rhnlib to resolve the dependence problem(source1)
- then we do not reauire rhnlib
- modify the comment of the menu(patch1)

* Wed Dec 01 2010 Liu Tingting <maggie.liu@asianux.com> 4.0-1
- Change location of config file. patch0
- Change program name of desktop menu. patch1
- Change tui interface to satisfy asianux. patch2
- Change gui interface to satisfy asianux. patch3
- Add function for asianux. patch4
